
##
## REMOTES
##

on *:LOAD:{
  echo Initializing setup..
  echo Commands:
  echo /asetup Initialiazes setup.
  echo /gone <reason> Sets away for the specified reason.
  echo /back [followup] Sets back and uses followup if followup is enabled.
  dialog -m ascript_table ascript_table
}
on *:TEXT:$(%ascript.tmsg.trigger):#:{
  %ascript.atime = $duration($calc($calc($ticks - %ascript.astart) * .001))
  if (%ascript.tmsg.enable == $true) {
    if (%ascript.away == $true) {
      $replace(%ascript.tmsg.format,^nick^,$nick,^chan^,$chan) $replace(%ascript.tmsg,^script^,%ascript.script,^version^,%ascript.version,^timeaway^,%ascript.atime,^nick^,$nick)
    }
  }
}

##
## ALIASES
##
alias asetup {
dialog -m ascript_table ascript_table
}
alias gone {
  if ($1) {
    %ascript.reason = $1-
  }
  else {
    %ascript.reason = %ascript.default
  }
  if (%ascript.amsg.enable == $true) {
    %ascript.amsg.format $replace(%ascript.amsg,^reason^,%ascript.reason,^script^,%ascript.script,^version^,%ascript.version)
  }
  %ascript.astart = $ticks
  if (%ascript.maway.enable == $true) {
    away %ascript.reason
  }
  if (%ascript.anick.enable == $true) {
    nick %ascript.anick
  }
  %ascript.away = $true
}

alias back {
  if (%ascript.away == $true) {
    %ascript.atime = $duration($calc($calc($ticks - %ascript.astart) * .001))
    if ($1) {
      %ascript.followup = $1-
    }
    else {
      %ascript.followup = NONE
    }
    if (%ascript.bmsg.enable == $true) {
      if (%ascript.followup.enable == $true) {
        %ascript.bmsg.format $replace(%ascript.bmsg,^reason^,%ascript.reason,^script^,%ascript.script,^version^,%ascript.version,^timeaway^,%ascript.atime,^followup^,%ascript.followup)
      }
      else {
        %ascript.bmsg.format $replace(%ascript.bmsg,^reason^,%ascript.reason,^script^,%ascript.script,^version^,%ascript.version,^timeaway^,%ascript.atime)
      }
    }
    if (%ascript.maway.enable == $true) {
      away
    }
    if (%ascript.anick.enable == $true) {
      nick %ascript.nick
    }
    %ascript.away = $false
  }
  else {
    echo You're not away!
  }
}

##
## DIALOGS
##
on *:dialog:ascript_table:init:*:{
  did -a ascript_table 5 Message All Chans
  did -a ascript_table 5 Message Active
  did -a ascript_table 5 Act in All Chans
  did -a ascript_table 5 Act in Active
  did -a ascript_table 5 Notice Active
  did -a ascript_table 5 Echo
  did -a ascript_table 5 Echo in Status
  did -a ascript_table 14 Message All Chans
  did -a ascript_table 14 Message Active
  did -a ascript_table 14 Act in All Chans
  did -a ascript_table 14 Act in Active
  did -a ascript_table 14 Notice Active
  did -a ascript_table 14 Echo
  did -a ascript_table 14 Echo in Status
  did -a ascript_table 26 Notice Nick
  did -a ascript_table 26 Message Nick
  did -a ascript_table 26 Notice Channel
  did -a ascript_table 26 Message Channel
  did -a ascript_table 26 Act in Channel
  did -a ascript_table 26 Act in Query
  did -a ascript_table 26 Echo
  did -a ascript_table 26 Echo in Status
  did -a ascript_table 1 %ascript.amsg
  did -a ascript_table 11 %ascript.bmsg
  did -a ascript_table 18 %ascript.script
  did -a ascript_table 19 %ascript.version
  did -a ascript_table 29 %ascript.nick
  did -a ascript_table 31 %ascript.anick
  did -a ascript_table 23 %ascript.tmsg.trigger
  did -a ascript_table 35 %ascript.tmsg
  if (%ascript.amsg.enable == $true) { did -c ascript_table 13 }
  if (%ascript.bmsg.enable == $true) { did -c ascript_table 12 }
  if (%ascript.anick.enable == $true) { did -c ascript_table 33 }
  if (%ascript.tmsg.enable == $true) { did -c ascript_table 22 }
  if (%ascript.followup.enable == $true) { did -c ascript_table 28 }
  if (%ascript.maway.enable == $true) { did -c ascript_table 21 }
  if (%ascript.amsg.format == amsg) {
    did -c ascript_table 5 1
  }
  elseif (%ascript.amsg.format == say) {
    did -c ascript_table 5 2
  }
  elseif (%ascript.amsg.format == ame) {
    did -c ascript_table 5 3
  }
  elseif (%ascript.amsg.format == describe $active) {
    did -c ascript_table 5 4
  }
  elseif (%ascript.amsg.format == notice $active) {
    did -c ascript_table 5 5
  }
  elseif (%ascript.amsg.format == echo) {
    did -c ascript_table 5 6
  }
  elseif (%ascript.amsg.format == echo -s) {
    did -c ascript_table 5 7
  }
  else {
    did -c ascript_table 5 1
  }
  if (%ascript.bmsg.format == amsg) {
    did -c ascript_table 14 1
  }
  elseif (%ascript.bmsg.format == say) {
    did -c ascript_table 14 2
  }
  elseif (%ascript.bmsg.format == ame) {
    did -c ascript_table 14 3
  }
  elseif (%ascript.bmsg.format == describe $active) {
    did -c ascript_table 14 4
  }
  elseif (%ascript.bmsg.format == notice $active) {
    did -c ascript_table 14 5
  }
  elseif (%ascript.bmsg.format == echo) {
    did -c ascript_table 14 6
  }
  elseif (%ascript.bmsg.format == echo -s) {
    did -c ascript_table 14 7
  }
  else {
    did -c ascript_table 14 1
  }
  if (%ascript.tmsg.format == notice ^nick^) {
    did -c ascript_table 26 1
  }
  elseif (%ascript.tmsg.format == msg ^nick^) {
    did -c ascript_table 26 2
  }
  elseif (%ascript.tmsg.format == notice ^chan^) {
    did -c ascript_table 26 3
  }
  elseif (%ascript.tmsg.format == msg ^chan^) {
    did -c ascript_table 26 4
  }
  elseif (%ascript.tmsg.format == describe ^chan^) {
    did -c ascript_table 26 5
  }
  elseif (%ascript.tmsg.format == describe ^nick^) {
    did -c ascript_table 26 6
  }
  elseif (%ascript.tmsg.format == echo) {
    did -c ascript_table 26 7
  }
  elseif (%ascript.tmsg.format == echo -s) {
    did -c ascript_table 26 8
  }
  else {
    did -c ascript_table 26 1
  }
}
on *:dialog:ascript_table:sclick:38:{
  %ascript.amsg = $did(1).text
  %ascript.bmsg = $did(11).text
  %ascript.script = $did(18).text
  %ascript.version = $did(19).text
  %ascript.nick = $did(29).text
  %ascript.anick = $did(31).text
  %ascript.tmsg = $did(35).text
  %ascript.tmsg.trigger = $did(23).text
  %ascript.amsg.enable = $replace($did(13).state,1,$true,0,$false)
  %ascript.bmsg.enable = $replace($did(12).state,1,$true,0,$false)
  %ascript.anick.enable = $replace($did(33).state,1,$true,0,$false)
  %ascript.tmsg.enable = $replace($did(22).state,1,$true,0,$false)
  %ascript.followup.enable = $replace($did(28).state,1,$true,0,$false)
  %ascript.maway.enable = $replace($did(21).state,1,$true,0,$false)
  %ascript.amsg.format = $gettok(amsg|say|ame|describe $ $+ active|notice $ $+ active|echo|echo -s,$did(5).sel,124)
  %ascript.bmsg.format = $gettok(amsg|say|ame|describe $ $+ active|notice $ $+ active|echo|echo -s,$did(14).sel,124)
  %ascript.tmsg.format = $gettok(notice ^nick^|msg ^nick^|notice ^chan^|msg ^chan^|describe ^chan^|describe ^nick^|echo|echo -s,$did(26).sel,124)
}
on *:dialog:ascript_table:sclick:39:{
  %ascript.amsg = $did(1).text
  %ascript.bmsg = $did(11).text
  %ascript.script = $did(18).text
  %ascript.version = $did(19).text
  %ascript.nick = $did(29).text
  %ascript.anick = $did(31).text
  %ascript.tmsg = $did(35).text
  %ascript.tmsg.trigger = $did(23).text
  %ascript.amsg.enable = $replace($did(13).state,1,$true,0,$false)
  %ascript.bmsg.enable = $replace($did(12).state,1,$true,0,$false)
  %ascript.anick.enable = $replace($did(33).state,1,$true,0,$false)
  %ascript.tmsg.enable = $replace($did(22).state,1,$true,0,$false)
  %ascript.followup.enable = $replace($did(28).state,1,$true,0,$false)
  %ascript.maway.enable = $replace($did(21).state,1,$true,0,$false)
  %ascript.amsg.format = $gettok(amsg|say|ame|describe $ $+ active|notice $ $+ active|echo|echo -s,$did(5).sel,124)
  %ascript.bmsg.format = $gettok(amsg|say|ame|describe $ $+ active|notice $ $+ active|echo|echo -s,$did(14).sel,124)
  %ascript.tmsg.format = $gettok(notice ^nick^|msg ^nick^|notice ^chan^|msg ^chan^|describe ^chan^|describe ^nick^|echo|echo -s,$did(26).sel,124)
  /dialog -x ascript_table ascript_table
}
on *:dialog:ascript_table:sclick:41:{
  /url -n http://www.stuffage.net/irc/
}
dialog ascript_table {
  title "nScript v5.0"
  size -1 -1 162 228
  option dbu
  edit "", 1, 2 65 157 10
  text "Away Message Layout:", 2, 2 57 58 8
  combo 5, 2 103 66 200, size drop
  text "^reason^ - Prints the reason you are away.", 6, 2 9 156 8
  text "^timeaway^ - Prints the amount of time you've been gone.", 7, 2 17 156 8
  text "^script^ - Prints the name of your script.", 8, 2 25 156 8
  text "^version^ - Prints the version of your script.", 9, 2 33 156 8
  text "Back Message Layout:", 10, 2 76 55 8
  edit "", 11, 2 84 157 10
  check "Enable", 12, 61 76 50 8
  check "Enable", 13, 61 57 50 8
  combo 14, 80 103 66 200, size drop
  text "Away Message Format:", 15, 2 95 58 8
  text "Back Message Format:", 16, 80 95 58 8
  text "Script Name: (IE nScript)", 17, 2 115 62 8
  edit "", 18, 2 123 66 10
  edit "", 19, 80 123 66 10
  text "Script Version: (IE v5.0)", 20, 80 115 61 8
  check "Use Standard mIRC Away Function", 21, 2 199 98 8
  check "Enable", 22, 50 134 27 8
  edit "", 23, 2 142 66 10
  text "Trigger Response:", 24, 2 134 45 8
  text "Trigger Response Format:", 25, 80 134 64 8
  combo 26, 80 142 66 200, size drop
  text "^followup^ - Prints a follow up message when returning.", 27, 2 41 156 8
  check "Enable Followups", 28, 2 191 54 8
  edit "", 29, 2 180 66 10
  text "Nick:", 30, 2 172 17 8
  edit "", 31, 80 180 66 10
  text "Away Nick:", 32, 80 172 28 8
  check "Enable", 33, 111 172 50 8
  edit "", 35, 2 161 157 10
  text "Trigger Response Layout:", 36, 2 153 88 8
  text "^nick^ - Prints the nick name who triggered the response.", 37, 2 49 156 8
  button "Apply", 38, 64 211 37 12
  button "OK", 39, 19 211 37 12, ok cancel
  button "Cancel", 40, 109 211 37 12, ok cancel
  link "http://www.stuffage.net/irc/", 41, 46 1 70 8
}
